<script setup lang="ts">
import { ref, onMounted } from 'vue'
import { useI18n } from 'vue-i18n'
import { useAppStore } from '../stores/AppStore'
import PageHeader from './PageHeader.vue'
import PageFooter from './PageFooter.vue'
import DialogBox from './DialogBox.vue'

// using
const { t } = useI18n({
	messages: {
		en: {
		},
		th: {
		},
	},
})
const appStore = useAppStore()

// props
const props = defineProps<{
	/**
	 * Display title.
	 */
	title?: string

	/**
	 * Hide header.
	 */
	hideHeader?: boolean

	/**
	 * Hide footer.
	 */
	hideFooter?: boolean

	/**
	 * Hidden the right menu.
	 */
	hideRightMenu?: boolean
}>()

// states
const dialogBox = ref(<InstanceType<typeof DialogBox> | null>null)

onMounted(() => {
	appStore.setupUi(dialogBox)
})
</script>


<style scoped>
#body {
	display: flex;
	flex-direction: column;
	height: 100vh;
}

main {
	padding: 2rem 1.5rem;
	flex: 1 0;
}
</style>


<template>
	<div id="body" :class="appStore.dark ? 'dark' : 'lite'">
		<PageHeader v-if="!props.hideHeader" :hideRightMenu="props.hideRightMenu" :title="title"></PageHeader>
		<main>
			<slot></slot>
		</main>
		<PageFooter v-if="!props.hideFooter"></PageFooter>
		<DialogBox ref="dialogBox" />
	</div>
</template>
